#ifndef __MSG_INTERCEPT
#define __MSG_INTERCEPT

#include "sg_error.h"

#pragma warning(disable:4100)
class MsgInterceptor {
public:
	//MsgInterceptor() {}

	virtual void onTaskPut(const char *whoHost, const char *destHost, const char *task, int channel) {}
	virtual void onTaskExecuteStart(const char *host, const char *procName, int procId, const char *task) {}
	virtual void onTaskExecuteFinish(const char *host, const char *procName, int procId, const char *task, SGError error) {}
	virtual void onProcessCreate(const char *whoHost, const char *fncName, const char *destHost) {}
	virtual void onProcessStart(const char *fncName, const char *host, const char *procName, int procId) {}
	virtual void onProcessTerminate(const char *fncName, const char *host, const char *procName, int procId, int retCode) {}
	virtual void onProcessSuspend(const char *host, const char *procName, int procId) {}
	virtual void onProcessResume(const char *host, const char *procName, int procId) {}

	virtual void onFunctionEntry(const char *fncName) {}
	virtual void onFunctionExit(const char *fncName) {}
};



#endif // __MSG_INTERCEPT
